/*

read rhto3 sensor Michael May -- April 2015 version 1.6 suitd for 8 mhz clock only
as timing dependent paremters in this version.

Fix error in loop causing odd errors in number conversion -- was missing last bit
and it only showed up sometimes.

Cleaned up the debug routines. port d0 can be switched if pulled up to change debug output on fly.


set bit 2 on port d for led represntation of a checksum error for noisy enviroment
cleared on next correct read.

Set timer 5 up to overflow if the sensor does not respond and advise on lcd and uart port
as was locked in non informative loop otherwise.
timer 5 prescaler set to 8 with a clock of 8 mhz instruction clock /4 so equals
.5 us * 8 so timer increments evry 4 Us.   so timer overflows after 262 milliseconds
As a total sensor read should only take 42 * 160 us roughly or around 7 millseconds
if the timer overflows the sensor is not connected or borked.

Oh yea sensor needs to be connected to Port C pin RC2 on develepment board.

Fixed negative number handaling error
Next version may be cpu clock independent. Maybe.

*/


//define lcd parameters
sbit LCD_RS at LATB4_bit;
sbit LCD_EN at LATB5_bit;
sbit LCD_D4 at LATB0_bit;
sbit LCD_D5 at LATB1_bit;
sbit LCD_D6 at LATB2_bit;
sbit LCD_D7 at LATB3_bit;

sbit LCD_RS_Direction at TRISB4_bit;
sbit LCD_EN_Direction at TRISB5_bit;
sbit LCD_D4_Direction at TRISB0_bit;
sbit LCD_D5_Direction at TRISB1_bit;
sbit LCD_D6_Direction at TRISB2_bit;
sbit LCD_D7_Direction at TRISB3_bit;

int BinaryBuffer[40];         //store converted time to 1 or 0
int buffer[42];               // store the elapsed time from the timer1 capture
//short int converted_byte = 0;
char *text = "000.0";


char byte_to_Binary(char ap){
   char  converted_byte = 0, x=0;
   bit mask_bit;
   text = "     "; //clear conversion buffer
   converted_byte = 0;
// bit building loop to construct a byte
  

   for (x=0; x<8; x++){              //fixed conversion loop error

       if (BinaryBuffer[ap] == 0)
       mask_bit  =0;
       else
       mask_bit =1;
                                        // bit shifting was annoying me so i
                                        //went lazy
       if (x == 0)
       converted_byte.b7 = mask_bit;
       
       if (x == 1)
       converted_byte.b6 = mask_bit;
       if (x == 2)
       converted_byte.b5 = mask_bit;
       if (x == 3)
       converted_byte.b4 = mask_bit;
       if (x == 4)
       converted_byte.b3 = mask_bit;
       if (x == 5)
       converted_byte.b2 = mask_bit;
       if (x == 6)
       converted_byte.b1 = mask_bit;
       if (x == 7)
       converted_byte.b0 = mask_bit;

       ap ++;              // point to next record

   }

return converted_byte;
}

void convert_byte_BIN(){
int index =2, bbindex=0;
//index pointer is offset by 2 due to spurious interupt on timer switch on and
//1 st data is sensor ack pulse then followed by the 40 data bits
// low bit determination bracket is 8Mhz / 4 =fosc
//this is .5 us so prescaller of 4 gives us 2us per timer increment
//sensor range for zero bit is 26 to 28 us so coupled with the 50us high time to next bit
//we get a timer value for 0 bit check twixt 40 to 89 us
// sensor range for one bit is 70us + 50 = 130 us
// we get a timer value for 1 bit check twixt 90 to 160 us


while(index<42){
                if (buffer[index] <= 0x30) {
                     BinaryBuffer[bbindex] = 0;
                     }
                if (buffer[index] > 0x30) {
                     BinaryBuffer[bbindex] = 1;
                     }
                     index ++;
                     bbindex ++;

                }

}

void number_to_str(int valitem){

text[0] = ' ';
if (valitem & 0x8000){ // negative number test
   
   text[0]= '-';
   valitem = valitem & 0x7fff;  //clear the 15th bit
   //or the number screws up doesnt work like the dallas code
   //valitem = ~valitem +1;         //fix the negative number
   }                              // forgot this in first draft
if (valitem / 100)
   text[1] = valitem /100 + 48;  //see if hundreds
   else
   text[1] = ' ';
   text[2] = (valitem /10)%10 + 48; //tens
   text[3] = '.';
   text[4] = valitem % 10 + 48;   // and 1s
                                  //done like this as the number needs to be
                                  //divided by 10 and the floattostr is rubish
                                  //for this job who needs 26.99999
                                  //and no round up funtion just floor
                                  //so we do it this way to get the corret output
                                  

}
void serial_nlcr(){
uart1_write(0x0d);
uart1_write(0x0a);
}
void data_conversion(){
int debugmode = 0; //set debug mode to 1 to dump data to serial port
char txt[6];
char humid_hi=0, humid_low=0, temp_hi_MM=0, temp_low=0, checksum =0, total = 0, x=0, i=0;
int humid_value =0, tempcelc_value =0;


if (portd.B0 == 1){
debugmode = 1;
   }
        do{
         humid_hi = byte_to_Binary(0);     //convert to 8 bit chars
         humid_low = byte_to_Binary(8);

         temp_hi_MM = byte_to_Binary(16);
         temp_low = byte_to_Binary(24);

         checksum = byte_to_Binary(32);
                                          //because sensor checksum is derived
                                          //by adding the 4 8 bit characters together
                                          //and it has to match the 5th char read
         total = humid_hi + humid_low + temp_hi_MM + temp_low;


         if (total != checksum){
            TRISD.TRISD2 = 1; //set port d2 for out
            LATD.LATD2 =1;    //set output hi turn on checksum error led
            delay_MS(2000); // wait 2 seconds before trying again
            if (debugmode ==0);                   //dont dump asci in advanced debug mode
            {uart1_Write_text("CheckSum Error");}
            serial_nlcr();
            
            for (x=2; x < 42; x++){   //dump the 40 bytes elapsed time as sent by sensor
            uart1_write(buffer[x]);

            }
            serial_nlcr();

            for (x=0; x <40; x++)        //dump the binary buffer so you can 
                                         //see if the conversion is correct manually
            {
            uart1_write(BinaryBuffer[x]);
            }
            serial_nlcr();

            uart1_Write(humid_hi);         //write the converted bytes so you can
            uart1_write(humid_low);        //see if the conversion routine is working
            uart1_write(temp_hi_MM);
            uart1_write(temp_low);
            uart1_write(checksum);
            serial_nlcr();

            }
    }
        while(total != checksum);  //part of the above do loop

         LATD.LATD2 = 0; //turn off checksum error led
         // okay if we got this far we should have valid figures to convert and print
         
         humid_value = (humid_hi << 8) | (humid_low & 0xff); //build interger 16 bits
         number_to_str(humid_value);   //convert and store in the global text array

         if (debugmode ==0){                   //if normal debug write ascii
            uart1_write_text (text);
            uart1_write_text (" Rel Humidity");
            serial_nlcr();
         }
         Lcd_out(1,1,"Rel Humidy");
         Lcd_out_cp(text);
         Lcd_Out_cp("%");

         
         tempcelc_value = (temp_hi_MM << 8) | (temp_low & 0xff); // build integer of 16 bits
         number_to_str(tempcelc_value);

         if (debugmode ==0){
         uart1_write_text(text);
         uart1_write_text(" Temp C");
         serial_nlcr();
         }
         
         Lcd_out(2,1,"Temp      ");
         Lcd_out_cp(text);
         Lcd_out_cp("c");
         

         }





char sensor_read(){
char bitcount =0, notvalid =0;
TMR5H = 0;      //clear timer 5
TMR5L = 0;
PIR5.TMR5IF = 0; // clear interup flag
T5CON.T5CKPS1 = 1;
T5CON.T5CKPS0 = 1; //set timer 5 prescaller to 8 to 1
T5CON.TMR5ON = 1; //switch on the timer

TRISC.B2 = 0;   // set sensor line to output
LATC.B2 = 0;    //bring sensor line down
Delay_MS(10);   //wait time for sensor to see request
LATC.B2 = 1;    // bring sensor line high
Delay_US(20);   // wait for sensor to see
TRISC.B2 = 1;   // switch sensor line to input for pulse read

T1CON.TMR1ON = 0; //timer1 off

TMR1H = 0;        //clear timer1h
TMR1L = 0;        //clear timerll to zero

T1CON.T1CKPS1=1;
T1CON.T1CKPS0=0; //set_Timer1 prescale  4:1

T1CON.TMR1ON; //switch on the timer
          while((bitcount <42) && (PIR5.TMR5IF == 0)){   //check tm5if to break out if no response
              if (PIR1.CCP1IF == 1){
                 T1CON.TMR1ON = 0; //switch off timer
                 Buffer[bitcount] = CCPR1; //save timer value to buffer
                 TMR1H = 0;        //clear the timer
                 TMR1L = 0;
                 bitcount++ ;      // increment buffer pointer
                 T1CON.T1CKPS1=1;  //reset prescaller to
                 T1CON.T1CKPS0=0;  // set_Timer1 prescale 4:1
                 PIR1.CCP1IF =0;   // clear capture compare flag
                 T1CON.TMR1ON = 1; //switch timer back on

                 }
               }
          T1CON.TMR1ON = 0; //shut off the timer
          bitcount=0;
          T5CON.TMR5ON = 0; //switch off the timer
          if (PIR5.TMR5IF == 1)
          notvalid = 1;
          else
          notvalid = 0;

          PIR5.TMR5IF == 0; //clear the flag

    return notvalid;  //returns a 1 if timer 5 overflowed indicating sensor failure


}
void initalise(){
//basic cpu setup
//designed for 8mhz clock 18f45k22
ANSELB = 0; // set port digital
ANSELC = 0; // Set port digital
ANSELD =0 ; //set port d as digital
TRISB.B7 = 0; //set port b for output
TRISC.B2 =1; // set ccp port as input
TRISD.B0 = 1; //set port d0 as input

CCP1CON = 0b00000100; //capture every falling edge.
//configure serial port
uart1_init(9600);
//timer 1 setup
T1CON.TMR1CS1 = 0;
T1CON.TMR1CS0 = 0;// select to internal instruction clock ... fosc/4
TMR1H = 0;
TMR1L = 0;
T1CON.TMR1ON = 0; //dont switch on yet
lcd_init(); //setup lcd display

}

void main() {
int index =2, bbindex=0;
int bitcount =0;
delay_MS(500); // wait for power to stabalise and lcd to catch up
initalise();
while(1){

               //read the Sensor
         while (sensor_read() == 1){
               LCD_CMD(_LCD_CLEAR);
               LCD_CMD(_LCD_CURSOR_OFF);
               LCD_OUT(1,1,"SENSOR NOT");
               LCD_OUT(2,1,"RESPONDING");
               uart1_write_text("Sensor Not Responding");
               serial_nlcr();
               delay_MS(3000); // wait 3 seconds and try again
               }
         convert_byte_bin();  //kludgy conversion routine to setup binary array
         LCD_CMD(_LCD_CLEAR);
         LCD_CMD(_LCD_CURSOR_OFF);
         data_conversion();  //convert binary array to human readabe format
         delay_MS(10000);    //wait 10 seconds and repeat.
         }
     }